#include <time.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#define S 4
using namespace std;

class Tournament
{
private:
    int tables;
    int rounds;
public:
    Tournament(int table, int round)
    {
        rounds = round;
        tables = table;
    }

    ~Tournament()
    {
    }

    void generate(int result[])
    {
        int *r;
        r = new int[2*tables];
        int c, d;

        // start searching: team 2
        init (r, 0, tables);
        do {
            c = check2(r);
            if (c == rounds)
            {
                // start searching: team 3
                init(r, tables, 2*tables);
                do {
                    d = check3(r);
                    if (d == rounds)
                        goto fin;
                    reverse(r+tables+d+1, r+2*tables);
                } while (next_permutation(r+tables, r+2*tables));
            }
            reverse(r+c+1, r+tables);
        } while (next_permutation(r, r+tables));

init(r, tables, 2*tables);
fin:
        // return
        for (int round = 0; round < rounds; round++)
        {
            result[round] = 0;
            result[rounds + round] = round;
        }
        for (int team = 2; team < 4; team++)
            for (int round = 0; round < rounds; round++)
                result[team*rounds+round] = r[(team-2)*tables+round];
    }
private:
    void init(int r[], int start, int end)
    {
        for (int i = 0; i < end-start; i++)
            r[start+i] = i;
    }

    int check2(int t[])
    {
        int round;
        for (round = 0; round < rounds; round++)
            for (int r = 0; r < round; r++)
                if (!((t[r]+round-r-t[round]) % tables))
                    return round;
        return rounds;
    }

    int check3(int t[])
    {
        int round;
        for (round = 0; round < rounds; round++)
            for (int r = 0; r < round; r++)
            {
                if (!((t[tables+r]+round-r-t[tables+round]) % tables))
                    return round;

                if (!((t[tables+r]+t[round]-t[r]-t[tables+round]) % tables))
                    return round;
            }
        return rounds;
    }
};

void genout(int table, int round)
{
    int *t;
    t = new int[S*round];
    Tournament tournament(table, round);
    tournament.generate(t);
    for (int team = 0; team < S; team++)
    {
        for (int curr = 0; curr < round; curr++)
            cout << t[team*round+curr] << " ";
        cout << endl;
    }
    delete[]t;
}

int input ()
{
    int ret;
    cin >> ret;
    return ret;
}

int tables ()
{
    cout << "tables?" << endl;
    return input();
}

int rounds()
{
    cout << "rounds?" << endl;
    return input();
}

void otime()
{
    time_t current;
    time(&current);
    struct tm *local;
    local = localtime(&current);
    cout << local->tm_hour << ":" << local->tm_min << ":" << local->tm_sec << endl;
}

main()
{
    int table;
    int round;
    while (table = tables())
    {
        round = rounds();
        if (round > table)
        {
            cout << "impossible!" << endl;
            continue;
        }
        cout << "start at ";
        otime();
        genout(table, round);
        cout << "end at ";
        otime();
        cout << endl;
    }
}
